function goodFeatures=process_data(trainset)
% Establish list of good features.
%
% Usage:
%
%    goodFeatures = process_data(trainset)
%
% trainset is the training dataset, in the format of ocr_data.mat
%
%  The output is a 64 x 26 logical matrix indicating the good features
% (those with sufficiently large counts in trainset)
%

        %   Get Counts for each feature
    counts              =   zeros(size(trainset.pixels,2),26);
    countTransitions    =   zeros(26);

    for it=1:size(trainset.letter)
        counts(:,trainset.letter(it))=counts(:,trainset.letter(it))+...
                                                trainset.pixels(it,:)';
        if(trainset.prev_letter(it)>0)
            countTransitions(trainset.prev_letter(it),trainset.letter(it))...
                =countTransitions(trainset.prev_letter(it),trainset.letter(it))+1;
        end
    end

        %   Threshold counts
    countthresh=1e-4*size(trainset.letter,1);
    goodFeatures.nodes=counts>countthresh;
    goodFeatures.edges=countTransitions>countthresh;
end

